
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>React 事件与表单 / iVAN</title>

    <meta name="description" content="React 事件与表单 React 事件 基本的事件运用 事件命名为驼峰式,事件处理方法命名驼峰式 handleClick, handleChange 事件类型 鼠标类事件:onClick, onMouseOver ... 拖拽类事件:onDrop, onDrag ... 触摸类事件:onTouchMove, onTouchStart ... 键盘事件:onKeyDown, onKeyUp ... 剪切类事件:onCopy, onPaste ... 表单类事件:onSubmit, onChange ... . . .">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">React 事件与表单</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>React 事件</h2>
<h3>基本的事件运用</h3>
<ul>
<li>事件命名为驼峰式，事件处理方法命名驼峰式 handleClick， handleChange</li>
<li>事件类型</li>
</ul>
<pre><code>鼠标类事件：onClick, onMouseOver ...
拖拽类事件：onDrop, onDrag ...
触摸类事件：onTouchMove, onTouchStart ...
键盘事件：onKeyDown, onKeyUp ...
剪切类事件：onCopy, onPaste ...
表单类事件：onSubmit, onChange ...
.
.
.
</code></pre>
<ul>
<li>基本事件处理 example</li>
</ul>
<pre><code>var EventExample01 = React.createClass({
  getInitialState: function() {
    return {
      text: ''
    };
  },
  handleClick: function(){
    this.setState({text: this.state.text ? '' : 'hello world'});
  },
  render: function() {
    return (
      &lt;div onClick={this.handleClick}&gt;
        &lt;div&gt;{this.state.text}&lt;/div&gt;
      &lt;/div&gt;
    );
  }
});

ReactDOM.render(&lt;EventExample01/&gt;,document.getElementById('example01'));
</code></pre>
<h3>事件相关属性</h3>
<p>react对原生事件进行了一次封装，命名为 SyntheticEvent，具备和原生事件相同的属性</p>
<ul>
<li>通用属性</li>
</ul>
<pre><code>bubbles (boolean) 表示事件是否冒泡
cancelable(boolean) 表示事件是否可以取消
currentTarget(DOMEventTarget) 与Target类似，由于事件可以冒泡，所以两者表示的内容是不同的
defaultPrevented(boolean) 表示事件是否禁止了默认行为
eventPhase(number) 表示事件所处的阶段
isTrusted(boolean) 表示事件是否可信。所谓的可信事件表示的是用户操作的事件，不可信事件就是通过JS代码来触发的事件。
nativeEvent(DOMEvent)
preventDefault() (void) 对应的defaultPrevented，表示的是禁止默认行为
stopPropagaTion() (void) 对应的是bubbles，表示的是sh
target(DOMEventTarget)
timeStamp(number) 时间戳，也就是事件触发的事件
type(string) 事件的类型
</code></pre>
<ul>
<li>特殊属性举例</p>
<pre><code>鼠标事件的 clientX 和 clientY
键盘事件的 key
...
</code></pre>
</li>
<li>冒泡特性举列</li>
</ul>
<p>例如有一个登陆框，我们想要在点击登陆框以外的范围时将登陆框关闭</p>
<pre><code>var LoginDialog =React.createClass({
  getInitialState: function() {
    return {
      claz: '',
      text: ''
    };
  },
  handleClick(e){
    console.log('click block!');
    e.nativeEvent.stopImmediatePropagation();     //IE9+
  },
  render: function() {
    return (
      &lt;div className={this.state.claz} onClick={this.handleClick}&gt;
        &lt;input value={this.state.text} onChange={(e)=&gt;{this.setState({text: e.target.value})}} /&gt;
      &lt;/div&gt;
    );
  },
  componentDidMount: function(){
    document.addEventListener('click', () =&gt; {
      console.log('body');
      this.setState({claz: 'fd-hide'});
    });

    ////验证事件是代理在 document 上的
    // document.body.addEventListener('click', () =&gt; {
    //   console.log('body');
    //   this.setState({claz: 'fd-hide'});
    // });
  }
});

ReactDOM.render(&lt;LoginDialog/&gt;, document.getElementById('fe'));
</code></pre>
<p>我们先在 document 上添加 click 事件处理 LoginDialog 的隐藏，然后在 LoginDialog 中也监听 click 事件，然后利用 stopImmediatePropagation 阻止相同元素上的同类型事件，就能实现需求的效果。<br />可见 react 的事件都是代理在 document 上的。由上面代码可以看出，如果我们把事件监听放在 document.body 上时，LoginDialog 中的阻止同类型事件触发就失效了。</p>
<h3>事件对象的持久化</h3>
<ul>
<li>一个例子来比较异步处理事件时原生和 SyntheticEvent 的区别</li>
</ul>
<pre><code>//原生事件 example
var exampleElement = document.getElementById('example');
exampleElement.addEventListener('click', function(e){
  setTimeout(function(){
    console.log(e.target);
  }, 0);
});

//SyntheticEvent example
var SyntheticEventExample = React.createClass({
  handleClick: function(e){
    setTimeout(function(){
      console.log(e.target);
    }, 0);
  },
  render: function() {
    return (
      &lt;div id="example" onClick={this.handleClick}&gt;
      &lt;/div&gt;
    );
  }
});

ReactDOM.render(&lt;SyntheticEventExample/&gt;,document.getElementById('example01'));

//对比两个的输出会发现原生的 example 能够输出 e.target，因为它的引用还在
//SyntheticEvent example 的输出为 null, 因为已经释放
</code></pre>
<ul>
<li>SyntheticEvent 持久化相关 React 源码解析</li>
</ul>
<pre><code>var SyntheticEventExample = React.createClass({
  handleClick: function(e){
    e.persist();
    setTimeout(function(){
      console.log(e.target);
    }, 0);
  },
  render: function() {
    return (
      &lt;div id="example" onClick={this.handleClick}&gt;
      &lt;/div&gt;
    );
  }
});

ReactDOM.render(&lt;SyntheticEventExample/&gt;,document.getElementById('example01'));

//加上 e.persist(); 后能够输出 e.target
//why?
</code></pre>
<p>SyntheticEvent 对象会在处理完判断 isPersistent，为 false 就释放对象</p>
<pre><code>//ResponderEventPlugin
if (!terminationRequestEvent.isPersistent()) {
     terminationRequestEvent.constructor.release(terminationRequestEvent);
   }
</code></pre>
<p>release 的相关实现，它会调用对象的 destructor 方法</p>
<pre><code>//react.js line:143
var standardReleaser = function (instance) {
  var Klass = this;
  !(instance instanceof Klass) ? "development" !== 'production' ? invariant(false, 'Trying to release an instance into a pool of a different type.') : _prodInvariant('25') : void 0;
  instance.destructor();
  if (Klass.instancePool.length &lt; Klass.poolSize) {
    Klass.instancePool.push(instance);
  }
};
</code></pre>
<p>SyntheticEvent 的析构函数实现，将属性置为了 null</p>
<pre><code>//SyntheticEvent
destructor: function() {
    var Interface = this.constructor.Interface;
    for (var propName in Interface) {
      if (__DEV__) {
        Object.defineProperty(this, propName, getPooledWarningPropertyDefinition(propName, Interface[propName]));
      } else {
        this[propName] = null;
      }
    }
    for (var i = 0; i &lt; shouldBeReleasedProperties.length; i++) {
      this[shouldBeReleasedProperties[i]] = null;
    }
    if (__DEV__) {
      Object.defineProperty(
        this,
        'nativeEvent',
        getPooledWarningPropertyDefinition('nativeEvent', null)
      );
      Object.defineProperty(
        this,
        'preventDefault',
        getPooledWarningPropertyDefinition('preventDefault', emptyFunction)
      );
      Object.defineProperty(
        this,
        'stopPropagation',
        getPooledWarningPropertyDefinition('stopPropagation', emptyFunction)
      );
    }
  },
</code></pre>
<p>而 SyntheticEvent 中 persist 方法做的就是将 isPersistent 变为一个返回 true 的函数</p>
<pre><code>//SyntheticEvent
/**
   * We release all dispatched `SyntheticEvent`s after each event loop, adding
   * them back into the pool. This allows a way to hold onto a reference that
   * won't be added back into the pool.
   */
  persist: function() {
    this.isPersistent = emptyFunction.thatReturnsTrue;
  },

  /**
   * Checks if this event should be released back into the pool.
   *
   * @return {boolean} True if this should not be released, false otherwise.
   */
  isPersistent: emptyFunction.thatReturnsFalse,
</code></pre>
<h2>React 表单</h2>
<h3>基本表单的运用</h3>
<p>表单是运用事件的一个很好的场景， 我们来看一个基本的表单实现</p>
<pre><code>var FormExample = React.createClass({
  getInitialState: function(){
    return {
      name: 'rube',
      password: '123456',
      selected: '1'
    }
  },
  handleNameChanged: function(event){
    this.setState({name: event.target.value});
  },
  handlePwdChanged: function(event){
    this.setState({password: event.target.value})
  },
  handleSelectedChanged: function(event){
    this.setState({selected: event.target.value});
  },
  render: function(){
    console.log('render');
    return (
      &lt;form&gt;
        &lt;input value={this.state.name} onChange={this.handleNameChanged}/&gt;
        &lt;input value={this.state.password} onChange={this.handlePwdChanged}/&gt;
        &lt;select value={this.state.selected} onChange={this.handleSelectedChanged}&gt;
          &lt;option value="1"&gt;1&lt;/option&gt;
          &lt;option value="2"&gt;2&lt;/option&gt;
          &lt;option value="3"&gt;3&lt;/option&gt;
        &lt;/select&gt;
      &lt;/form&gt;
    );
  }
});

ReactDOM.render(&lt;FormExample/&gt;, document.getElementById('example'));
</code></pre>
<p>如果我们运行上面的代码会发现，render 会输出很多次，每一次 state 变动都会触发重新 render，这可能会对性能造成一定的影响。<br />同时这样的表单在表单值控制，表单校验的能力上都较弱，因此我们看看有没有什么更好地实现</p>
<h3>另一个表单的实现</h3>
<pre><code>var InputComponent = React.createClass({
  contextTypes: {
    rubeform: React.PropTypes.object
  },
  getInitialState: function(){
    return {
      value: this.context.rubeform.data[this.props.name]
    }
  },
  render: function(){
    return (
      &lt;div&gt;
      &lt;input value={this.state.value} onChange={this.context.rubeform.change.bind(this, this)}/&gt;
      &lt;/div&gt;
    );
  }
});

var RubeForm = React.createClass({
  render: function(){
    console.log('render');
    return (
      &lt;form onSubmit={this.props.submit}&gt;
        &lt;InputComponent name='a'/&gt;
        &lt;InputComponent name='b'/&gt;
        &lt;InputComponent name='c'/&gt;
        &lt;InputComponent name='d'/&gt;
        &lt;input type='submit' value='submit'/&gt;
      &lt;/form&gt;
    )
  }
});

var FormExample02 = React.createClass({
  childContextTypes: {
    rubeform: React.PropTypes.object,
  },
  data: {
    a: 'default hello a',
    b: 'default hello b',
    c: 'default hello c',
    d: 'default hello d'
  },
  getChildContext: function(){
    var _this = this;

    return {
      rubeform: {
        change: function(){
          this.setState({value: arguments[1].target.value});
          _this.data[this.props.name] = arguments[1].target.value;
        },
        data: _this.data
      }
    }
  },
  render: function(){
    return (
      &lt;RubeForm submit={this.onSubmit}/&gt;
    );
  },
  onSubmit: function(e){
    window.alert(`You submitted:\n\n${JSON.stringify(this.data, null, 2)}`)
    e.preventDefault();
  }
});

ReactDOM.render(&lt;FormExample02/&gt;, document.getElementById('example'));
</code></pre>
<p>运行这个实例上看，我们直接改变了 InputComponent 的 state 从而不触发外部 form 的 render， 相关数据和操作由 context 传入，<br />
能够很好地对验证时机和表单数据进行控制</p>
<p>react Context 相关介绍 <a href="http://reactjs.cn/react/docs/context.html" rel="external nofollow noreferrer">http://reactjs.cn/react/docs/context.html</a></p>
<h3>redux-form 部分实现解析</h3>
<ul>
<li>redux-form 的例子</li>
</ul>
<pre><code>import React from 'react'
import { Field, reduxForm } from 'redux-form'

const SimpleForm = (props) =&gt; {
  const { handleSubmit, pristine, reset, submitting } = props
  return (
    &lt;form onSubmit={handleSubmit}&gt;
      &lt;div&gt;
        &lt;label&gt;First Name&lt;/label&gt;
        &lt;div&gt;
          &lt;Field name="firstName" component="input" type="text" placeholder="First Name"/&gt;
        &lt;/div&gt;
      &lt;/div&gt;
      &lt;div&gt;
        &lt;label&gt;Last Name&lt;/label&gt;
        &lt;div&gt;
          &lt;Field name="lastName" component="input" type="text" placeholder="Last Name"/&gt;
        &lt;/div&gt;
      &lt;/div&gt;
      &lt;div&gt;
        &lt;label&gt;Email&lt;/label&gt;
        &lt;div&gt;
          &lt;Field name="email" component="input" type="email" placeholder="Email"/&gt;
        &lt;/div&gt;
      &lt;/div&gt;
      &lt;div&gt;
        &lt;label&gt;Sex&lt;/label&gt;
        &lt;div&gt;
          &lt;label&gt;&lt;Field name="sex" component="input" type="radio" value="male"/&gt; Male&lt;/label&gt;
          &lt;label&gt;&lt;Field name="sex" component="input" type="radio" value="female"/&gt; Female&lt;/label&gt;
        &lt;/div&gt;
      &lt;/div&gt;
      &lt;div&gt;
        &lt;label&gt;Favorite Color&lt;/label&gt;
        &lt;div&gt;
          &lt;Field name="favoriteColor" component="select"&gt;
            &lt;option&gt;&lt;/option&gt;
            &lt;option value="ff0000"&gt;Red&lt;/option&gt;
            &lt;option value="00ff00"&gt;Green&lt;/option&gt;
            &lt;option value="0000ff"&gt;Blue&lt;/option&gt;
          &lt;/Field&gt;
        &lt;/div&gt;
      &lt;/div&gt;
      &lt;div&gt;
        &lt;label htmlFor="employed"&gt;Employed&lt;/label&gt;
        &lt;div&gt;
          &lt;Field name="employed" id="employed" component="input" type="checkbox"/&gt;
        &lt;/div&gt;
      &lt;/div&gt;
      &lt;div&gt;
        &lt;label&gt;Notes&lt;/label&gt;
        &lt;div&gt;
          &lt;Field name="notes" component="textarea"/&gt;
        &lt;/div&gt;
      &lt;/div&gt;
      &lt;div&gt;
        &lt;button type="submit" disabled={pristine || submitting}&gt;Submit&lt;/button&gt;
        &lt;button type="button" disabled={pristine || submitting} onClick={reset}&gt;Clear Values&lt;/button&gt;
      &lt;/div&gt;
    &lt;/form&gt;
  )
}

export default reduxForm({
  form: 'simple'  // a unique identifier for this form
})(SimpleForm)
</code></pre>
<p>redux-form 用 Field 来替代了每个输入域，那我们重点来看下 Field</p>
<pre><code>//redux-form/src/Field.js line:91
//每个 Field 其实最终会 render 一个 ConnectedField

render() {
      return createElement(ConnectedField, {
        ...this.props,
        name: this.name,
        normalize: this.normalize,
        _reduxForm: this.context._reduxForm,
        ref: 'connected'
      })
    }
</code></pre>
<pre><code>//redux-form/src/ConnectedField.js line:134
const connector = connect(
    (state, ownProps) =&gt; {
      const { name, _reduxForm: { initialValues, getFormState } } = ownProps
      const formState = getFormState(state)
      const initialState = getIn(formState, `initial.${name}`)
      const initial = initialState !== undefined ? initialState : (initialValues &amp;&amp; getIn(initialValues, name))
      const value = getIn(formState, `values.${name}`)
      const submitting = getIn(formState, 'submitting')
      const syncError = getSyncError(getIn(formState, 'syncErrors'), name)
      const syncWarning = getSyncWarning(getIn(formState, 'syncWarnings'), name)
      const pristine = value === initial
      return {
        asyncError: getIn(formState, `asyncErrors.${name}`),
        asyncValidating: getIn(formState, 'asyncValidating') === name,
        dirty: !pristine,
        pristine,
        state: getIn(formState, `fields.${name}`),
        submitError: getIn(formState, `submitErrors.${name}`),
        submitting,
        syncError,
        syncWarning,
        value,
        _value: ownProps.value // save value passed in (for checkboxes)
      }
    },
    undefined,
    undefined,
    { withRef: true }
  )
  return connector(ConnectedField)
</code></pre>
<p>ConnectedField 会关联 _reduxForm 的 initialValues, getFormState， 看看 _reduxForm 从何而来，是用 Context 从上层传递下来的，详见如下代码</p>
<pre><code>//redux-form/src/reduxForm.js line:120
getChildContext() {
           return {
             _reduxForm: {
               ...this.props,
               getFormState: state =&gt; getIn(this.props.getFormState(state), this.props.form),
               asyncValidate: this.asyncValidate,
               getValues: this.getValues,
               sectionPrefix: undefined,
               register: this.register,
               unregister: this.unregister,
               registerInnerOnSubmit: innerOnSubmit =&gt; this.innerOnSubmit = innerOnSubmit
             }
           }
         }

</code></pre>
<p>总体下来看，redux-from 和我们自己上面自己实现的那个高级一点的 form 原理是不是微微有点像呢~，它也是将一个 _reduxForm 由 Context 传递到子组件然后将子组件的 state 托管到 _reduxForm 里面<br />具体的校验什么的能力就不展开了，具体查看官方 demo <a href="http://redux-form.com/" rel="external nofollow noreferrer">http://redux-form.com/</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 01:35:44</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/javascript/" title="javascript">javascript</a>, <a href="https://www.iamivan.net/tag/%e9%98%bf%e9%87%8c%e6%8a%80%e6%9c%af%e5%8d%8f%e4%bc%9a/" title="阿里技术协会">阿里技术协会</a>, <a href="https://www.iamivan.net/tag/react/" title="react">react</a>, <a href="https://www.iamivan.net/tag/%e5%89%8d%e7%ab%af%e4%b8%8e%e4%ba%a4%e4%ba%92%e8%ae%be%e8%ae%a1/" title="前端与交互设计">前端与交互设计</a>, <a href="https://www.iamivan.net/tag/render/" title="render">render</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>React 事件与表单的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvrRkrM.html" rel="bookmark">如何阻止复制剪切和粘贴事件为了表单内容的安全&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在一些应用中,有时我们提交表单内容如(密码)重要信息时,为了安全,需要阻止一些复制剪切和粘贴事件,今天做了一个简单的例子有关阻止复制剪切和粘贴事件: 复制代码 代码如下: &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; &lt;meta charset=&quot; utf-8&quot;&gt; &lt;title&gt;pwd不能复制粘贴&lt;/title&gt; &lt;script type=&quot;text/javascript&quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1wg29z.html" rel="bookmark">模拟用户操作Input元素，不会触发相应事件&lowbar;表单特效</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Javascript中input元素的一个普遍规则是,只有用户的操作,才会出发input类的各种元素的对应事件,而是使用javascript的对应方法模拟用户操作,并不会触发相应的事件. 例如对于下面的表单: &lt;form name=&quot;form0&quot;&gt; &lt;input type=&quot;button&quot; value=&quot;按钮0&quot; name=&quot;b0&quot; onClick=&quot;alert('单击按钮0');&quot;&gt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mlg9gRb.html" rel="bookmark">兼容Firefox和IE的onpropertychange事件oninput&lowbar;表单特效</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在文本框输入数据的时候,当键盘按下并放开的时候可以使用onkeyup来检测事件,onpropertychange能够捕获每次改变,而onchange需要执行某个事件才可以捕获.可是有的时候我们输入数据是采用粘贴的方式而不是键盘输入,这就需要实时检测文本框状态的改变.onpropertychange 不被firefox所支持,如果想在firefox下正常使用,需要用oninput属性,且需要用addEventListener来注册事件. [Ctrl+A 全选 注:如需引入外部Js需刷新才能执行]			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvvB88M.html" rel="bookmark">Select的OnChange&lpar;&rpar;事件&lowbar;表单特效</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				请选择 Item 1 Item 2 Item 3 [Ctrl+A 全选 注:如需引入外部Js需刷新才能执行]			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEZ1qLM.html" rel="bookmark">jQuery表单事件实例代码分享&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例为大家分享了jQuery表单事件代码,供大家参考,具体内容如下 &lt;!DOCTYPE html&gt; &lt;html lang=&quot;en&quot;&gt; &lt;head&gt; &lt;meta charset=&quot;UTF-8&quot;&gt; &lt;title&gt;表单事件&lt;/title&gt; &lt;/head&gt; &lt;style type=&quot;text/css&quot; rel=&quot;stylesheet&quot;&gt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7X2Lab.html" rel="bookmark">js 常用的表单事件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.单击事件___onclick 用户单击鼠标按键时产生的事件.同时onclick指定的事件处理程序或代码将被调用执行. 如:&lt;input type=&quot;button&quot; value=&quot;打开页面&quot; onlick=&quot;window.open('xxxx.html','newwindow','width=456,height=230,toolbar=no,menubar=no,scrollbars=yes');&quot;&gt;   2. 改变事件___on			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdmmw1z.html" rel="bookmark">利用JS提交表单的几种方法和验证&lpar;必看篇&rpar;&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				工作中发现表单提交方便的问题,很多时候IE下提交好好的,打了火狐下就出现了问题,利用提交按钮就不成功了,于是利用JS的方式就成功了,也不知道为什么.在导师的催促下就总结出以下的几种常用表单提交的方法. 第一种方式:表单提交,在form标签中增加onsubmit事件来判断表单提交是否成功 &lt;script type=&quot;text/javascript&quot;&gt; function validate(obj) { if (confirm(&quot;提交表单?&quot;)) { aler			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGroxkp.html" rel="bookmark">JavaScript 表单验证常用代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JavaScript 可用来在数据被送往服务器前对 HTML 表单中的这些输入数据进行验证. 被 JavaScript 验证的这些典型的表单数据有: •用户是否已填写表单中的必填项目? •用户输入的邮件地址是否合法? •用户是否已输入合法的日期? •用户是否在数据域 (numeric field) 中输入了文本? 下面是连同 HTML 表单的完整代码:  代码如下 复制代码 &lt;html&gt; &lt;head&gt; &lt;script type=&quot;text/javascript&qu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvWE5Wp.html" rel="bookmark">Ajax提交表单时如何将kindeditor编辑器中的内容赋值给textarea</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				KindEditor在火狐下或者其他浏览器下都无法得到textarea文本框的值. 首先描述下我这边遇到的KindEditor错误现象: 1.在IE8/FF下均得不到值: 2.当点击KindEditor的全屏按钮切换到全屏模式输入时,再返回正常模式,可以得到值: 3.我用的是jQuery的ajax点击事件提交表单的,无法得到值: 4.直接用表单的提交按钮可以得到值. 那么如何解决上述的这些问题呢?  代码如下 复制代码 &lt;script type=&quot;text/javascript&quot;			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bo3rvb.html" rel="bookmark" class="title">配置IIS服务器时需要注意的地方</a>
					<div>
						介绍五种配置IIS服务器时需要注意的地方,把好安全关是所有网站都必须要做好的功课,如果服务器本身不安全,给网站带来的将是毁灭性的. 一.操作系统的安装 我这里说的操作系统以Windows 2000为例 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqr73p.html" rel="bookmark" class="title">Items 方法</a>
					<div>
						  返回一个数组,其中包含了一个 Dictionary 对象中的所有条目. object.Items( ) 其中 object 总是一个 Dictionary 对象的名称. 说明 下面这段代码说明了  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM111dM.html" rel="bookmark" class="title">mysql创建存储过程并在php中调用</a>
					<div>
						今天web开发中遇到需要利用php调取mysql的存储过程的,研究了半天终于小有所成,下面将如何使用mysql创建存储过程以及如何使用php调用mysql的存储过程做个记录,以防忘记. 1.在PHPm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmqK3p.html" rel="bookmark" class="title">将Access数据库移植到SQL Server 7&period;0</a>
					<div>
						access|server|数据|数据库 随着用户对于企业级高性能数据库的需求的增长,用户时常要从Microsoft Access Jet引擎的文件-服务器环境下转换到 Microsoft SQL S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKd16p.html" rel="bookmark" class="title">使用Rational Method Composer和Jazz实现开发过程的文档化和自动化（四）</a>
					<div>
						创建新的流程资产 场景:创建新的流程资产 在本系列文章的第 2 和第 3 部分中,我们了解了 JKE 组织的 Business Recovery Matters (BRM) 团队如何迅速配置其项目环境 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPN5omb.html" rel="bookmark" class="title">PS鼠绘漂亮的粉色人物插画</a>
					<div>
						鼠绘漂亮的粉色人物插画 好看的插画当然在制作的时候是要更多的努力和细心.不仅需要精心安排每一个元素,就连细节部分都需要全力去刻画,把质感,光感,立体感等全部完美的表现出来,这样出来的作品才是精品 .  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7vVVM.html" rel="bookmark" class="title">滤镜及变形工具制作绚丽的像素背景</a>
					<div>
						  制作小三角像素背景的方法跟星光背景有点类似,都是把素材复制两层,分别执行正负45度的滤镜(小三角像素背景执行滤镜之前需要先变形),然后修改图层的不透明度或混合模式就可以得到想要的效果. 最终效果  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balO3Qz.html" rel="bookmark" class="title">Dreamweaver网页设计：多彩文字链接</a>
					<div>
						文字链接是网页中最常见的页面元素,在默认状态下,文字链接样式都是带下划线的,这种一陈不变的外观使网页无法凸现个性和满足布局的需要.为了使文字链接符合页面的整体效果,可以采用 CSS (样式)来实现多样 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2w9kb.html" rel="bookmark" class="title">TP-Link TL-WR842N管理员密码是多少？</a>
					<div>
						  我们在浏览器中输入tplogin.cn(或者192.168.1.1)后,会弹出一个对话框,要求输入管理员密码,但我们都不知道管理员密码是多少?那要怎么输入? 步骤如下: 但是很多用户却不知道TP- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6217YM.html" rel="bookmark" class="title">Excel2010拆分单元格图文步骤</a>
					<div>
						  Excel2010拆分单元格图文步骤           举例:想把第一列按固定宽度分列,把另一列按/分隔符分列. Excel2010 在上方工具栏点数据,找到分列图标. Excel2010 选中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2xq5p.html" rel="bookmark" class="title">Photoshop给石阶上人物调出柔和的红褐色</a>
					<div>
						图片颜色比较分明,包含绿植绿色及石阶部分的中性色.调色的时候可以直接用调色工具把绿色等转为暖色,然后给整体增加暖色,暗部再增加红褐色即可. 原图 &lt;点小图查看大图&gt; 最终效果 1.打开素材 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo722Vb.html" rel="bookmark" class="title">IE浏览器开发人员工具中实用的&OpenCurlyDoubleQuote;小工具&rdquo;</a>
					<div>
						  自IE8浏览器开始,微软在IE中内置了开发人员工具,一般用户而言大概很少在使用吧?不过小编要说的,虽然这是一款开发人员工具,但是里面却有很多实用的&quot;小工具&quot;噢! 按一下键盘上F ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYddoM.html" rel="bookmark" class="title">QQ电脑管家登陆不了怎么回事</a>
					<div>
						  出现QQ号码无法登录电脑管家,您先关闭管家后重新启动管家,看是否有错误提示,然后再重新登录试一下.如果没有错误提示,请用您这个QQ号码登录一下QQ旋风.QQ音乐等是否正常.如果多次尝试之后仍然无法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7rGWz.html" rel="bookmark" class="title">潜谈IT从业人员在传统IT和互联网之间的择业问题&lpar;上&rpar;-传统乙方形公司</a>
					<div>
						外包能去吗?项目型公司如何?甲方比乙方好?互联网公司就一定好吗? 相信许多从业者在经历了3-5年的工作期后都会带着这样的疑问或者疑惑. 2012年-2014年间,曾经面试过500人,亲身面试的也有15 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQgjOp.html" rel="bookmark" class="title">java-Httpclient4&period;3 设置请求超时的问题呢</a>
					<div>
						问题描述 Httpclient4.3 设置请求超时的问题呢 问题描述: 多线程使用httpclient调用接口时,一直保持响应,连接不断开. 增加了线程了,和超时的设置,但是仍然不能保证响应过长,断开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE47oAz.html" rel="bookmark" class="title">手机发的帖子的手机号</a>
					<div>
						问题描述 用手机发的帖子,怎样根据贴子查到他的手机号呢?各位达人帮帮忙吧???先谢了!!! 解决方案 解决方案二:引用楼主zzmxygfx3的回复: 用手机发的帖子,怎样根据贴子查到他的手机号呢?各位 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZOdnz.html" rel="bookmark" class="title">漫游费取消是必然趋势</a>
					<div>
						石美君 长久以来手机漫游费都被消费者认为是电信业最不合理的收费之一.在之前的一份调查中显示,有高达96.8%的用户表示应该取消漫游费.昨日,新疆通信管理局发布公告,自8月1日起,和田地区.喀什地区.克 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ALjVz.html" rel="bookmark" class="title">服务密码输入错误是有人盗用话费</a>
					<div>
						服务密码输入错误是有人盗用话费 手机突然收到运营商短信,说服务密码输入错误,这是有人在盗取自己的话费吗? 街坊邵先生就向记者反映说,最近身边很多朋友都收到了类似的短信,提示说服务密码输入错误,还有两次 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqR1PKp.html" rel="bookmark" class="title">不怕丢数据 VPS定时自动备份终极指南</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 近半年,先后丢失5个网站数据,大多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRxX3b.html" rel="bookmark" class="title">清科Z-club：童士豪、王啸等解析&OpenCurlyDoubleQuote;移动社交的下一个路口&rdquo;</a>
					<div>
						移动社交整合了移动网络.手机终端和社交服务的优势与特长,成为移动互联网时代的标志性产物.2012年,微信凭借用户规模的快速增长,成为了移动社交领域当之无愧的明星产品.而陌陌.唱吧等社交产品的火爆也引燃 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQLE4p.html" rel="bookmark" class="title">如何最有效率地学习机器学习</a>
					<div>
						在过去的两年时间里,我多次迷恋于学习机器学习. 正如你学习大多数的东西一样,每当我决定尝试新事物的时候,我不得不重新学习某些概念和课程. 所以,我编辑了一份包括概念.定义.资源以及工具的知识合集,这对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44yKNz.html" rel="bookmark" class="title">最伟大的创意都是令人恐惧的（一）新搜索引擎</a>
					<div>
						编者注:http://www.aliyun.com/zixun/aggregation/13830.html&quot;&gt;Paul Graham是美国互联网界的教父级人物,他创办了Y Combi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWaAkz.html" rel="bookmark" class="title">百度披露&OpenCurlyDoubleQuote;凤巢&rdquo;功能细节 可实现分IP投放</a>
					<div>
						网易科技讯 3月16日消息,百度上周在一个名为&quot;决胜ROI-搜索引擎营销全攻略&quot;的广告主推介论坛上,进一步披露了全新搜索推广广告专业版&quot;凤巢&quot;的功能细节,该全新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ24Nkz.html" rel="bookmark" class="title">重写document&period;write实现无阻塞加载js广告&lpar;补充&rpar;&lowbar;javascript技巧</a>
					<div>
						无阻塞加载javascript,对于页面性能优化有很大的作用,这样能有效的减少js对页面加载的阻塞.特别是一些广告js文件,由于广告内容有可能是富媒体,更是很可能成为你页面加载提速的瓶颈,高性能jav ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWZ18z.html" rel="bookmark" class="title">打飞机游戏终极BOSS Android实战打飞机游戏完结篇&lowbar;Android</a>
					<div>
						本文实例为大家分享了打飞机游戏BOSS以及胜利失败页面设计的Android代码,具体内容如下 修改子弹类: public class Bullet { //子弹图片资源 public Bitmap b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVNEBz.html" rel="bookmark" class="title">jQuery数组&lpar;&dollar;&period;each&comma;&dollar;&period;grep&comma;&dollar;&period;map&comma;&dollar;&period;merge&comma;&dollar;&period;inArray&comma;&dollar;&period;unique&comma;&dollar;&period;makeArray&rpar;处理函数详解</a>
					<div>
						1. $.each(array, [callback]) 遍历[常用] 解释: 不同于例遍jQuery对象的$().each()方法,此方法可用于例遍任何对象.回调函数拥有两个参数:第一个为对象的成员 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxE8wGp.html" rel="bookmark" class="title">网站优化中常见的一些错误事项</a>
					<div>
						首先,网站优化急不得,有很多的seo教程在网站完成的初期就急于让网站上线.他们只想到如果早让网站上线就可以早一点被收录.可是事实却并非如此,接下来就会有很多不利的事情接踵而来.因为每一个网站在刚刚完成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Z46wz.html" rel="bookmark" class="title">急求 Applet 有关事件模型 的问题~</a>
					<div>
						问题描述 急求高手-指点,万分感谢~问题如下:一个顶层的Applet,下面加载了很多的Swing组件,因为代码量比较大,现在一时摸不清组件间的层级关系,如何指定一个JPanel的鼠标点击事件,调用顶层 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNm1m7b.html" rel="bookmark" class="title">计算机取证如何追踪网络罪犯？</a>
					<div>
						本文讲的是计算机取证如何追踪网络罪犯?,作为调查人员,这些安全专家们按图索骥.就让我们从一系列案例中,窥探商业软件是怎么帮助技术人员搞定犯罪取证的吧. 老板接到线报,有员工打算离职,还想带走尽可能多的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8GZgNM.html" rel="bookmark" class="title">不重视组织管理工作不是好公司</a>
					<div>
						本·霍洛维茨( 腾讯科技配图)据国外媒体报道,一家公司的组织管理工作对公司而言异常的重要,而硅谷知名企业家霍洛维茨就对此有着很深刻的认识.本·霍洛维茨(Ben Horowitz)曾是企业软件公司Ops ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
